- name: Requestbody for service account role
  set_fact:
    role_request:
      cluster:
        - "monitor"
      indices:
        - names:
            - "*"
          privileges: "{{ config.elastic.fluent_service_account_privileges | default(default_privileges) }}"
      applications: []
  vars:
    default_privileges: 
      - "create"
      - "create_index"
      - "view_index_metadata"
      - "write"

- name: Create/update service account role
  uri:
    url: https://{{ config.elastic.fqdn }}/_security/role/{{ service_account }}
    method: "PUT"
    headers: "{{ kibana_rest_headers }}"
    body_format: json
    body: "{{ role_request }}"
    status_code: 200

- name: Requestbody for service account
  set_fact:
    serviceaccount_request:
      password: "{{ password }}"
      roles:
        - "{{ service_account }}"
      metadata: {}

- name: Create/update service account
  uri:
    url: https://{{ config.elastic.fqdn }}/_security/user/{{ service_account }}
    method: "PUT"
    headers: "{{ kibana_rest_headers }}"
    body_format: json
    body: "{{ serviceaccount_request }}"
    status_code: 200
